# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class TerrainApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_terrain_item(self, te_no, **kwargs):  # noqa: E501
        """Retrieves a Terrain resource.  # noqa: E501

        Retrieves a Terrain resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terrain_item(te_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str te_no: Resource identifier (required)
        :return: TerrainJsonldTerrain
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_terrain_item_with_http_info(te_no, **kwargs)  # noqa: E501
        else:
            (data) = self.get_terrain_item_with_http_info(te_no, **kwargs)  # noqa: E501
            return data

    def get_terrain_item_with_http_info(self, te_no, **kwargs):  # noqa: E501
        """Retrieves a Terrain resource.  # noqa: E501

        Retrieves a Terrain resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terrain_item_with_http_info(te_no, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str te_no: Resource identifier (required)
        :return: TerrainJsonldTerrain
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['te_no']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_terrain_item" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'te_no' is set
        if ('te_no' not in params or
                params['te_no'] is None):
            raise ValueError("Missing the required parameter `te_no` when calling `get_terrain_item`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'te_no' in params:
            path_params['teNo'] = params['te_no']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/terrains/{teNo}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TerrainJsonldTerrain',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
